Foreman - Bug #33633

Command 'hammer template combination create’' Fails when Organization and Location Used
10/05/2021 08:47 AM - Tomer Brisker

Status: New
Priority: Normal
Assignee:

Category:

Target version:

Difficulty: Fixed in Releases:
Triaged: No Found in Releases:
Bugzilla link: 1888482 Red Hat JIRA:

Pull request:

Description
Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1888482

Description of problem:

When using the "hammer template combination create” command, if the --organization flag and --location flag are used, an error is
thrown.

COMMAND RAN:

hammer> template combination create —--provisioning-template-id=55 --hostgroup-id=5 --organization-
id=1 --location=2
Could not create the template combination:
Internal Server Error: the server was unable to finish the request. This may be caused by una
vailability of some required servion in the server's logs.

ERROR FROM FOREMAN/PRODUCTION.LOG:

2020-10-14T20:16:58 [I|apple77£5501] Started POST "/api/hostgroups/5/template_combinations" for 19
2.168.0.24 at 2020-10-14 20:16:58 -0400

2020-10-14T20:16:58 [I|apple77£5501] Processing by Api::V2::TemplateCombinationsController
#create as JSON

2020-10-14T20:16:58 [I|apple77£5501] Parameters: {"location_id"=>2, "organization_id"=>1
, "provisioning_template_id"=>55, "template_combination"=>{"hostgroup_id"=>5}, "apiv"=>"v2", "host
group_1id"=>"5"}

2020-10-14T20:16:59 [D|apple77£5501] Authenticated user admin against INTERNAL authenticat
ion source

2020-10-14T20:16:59 [I|apple77£5501] Authorized user admin (Admin User)

2020-10-14T20:17:00 [D|tax|e77£5501] Current location set to Denver

2020-10-14T20:17:00 [D|tax|e77£5501] Current organization set to Studio-14

2020-10-14T20:17:00 [D|tax|e77£5501] Current location set to Denver

2020-10-14T20:17:00 [D|tax|e77£5501]

2020-10-14T20:17:00 [W|apple77£5501] Action failed

2020-10-14T20:17:00 [D|apple77£5501] Backtrace for 'Action failed' error (NoMethodError):
undefined method "template_combinations' for #&1lt;Location:0x00007£347£1226d0&gt;

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activemodel-5.2.1/1ib/active_model/attr
ibute_methods.rb:430:in "method_missing'

/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1lib/audited/auditor.rb:99:in "m
ethod_missing'

Current organization set to Studio-14

/usr/share/foreman/app/controllers/api/v2/template_combinations_controller.rb:42:in " creat
el

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_controller/
metal/basic_implicit_render.rb:6:in "“send_action'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/abstract_controlle
r/base.rb:194:in “process_action'

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_controller/
metal/rendering.rb:30:in "“process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/abstract_controlle
r/callbacks.rb:42:in “block in process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
callbacks.rb:109:in “block in run_callbacks'
/usr/share/foreman/app/controllers/api/v2/base_controller.rb:163:in “disable_json_root'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
callbacks.rb:118:in "block in run_callbacks'
/usr/share/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:1in "set_time
zone'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/
callbacks.rb:118:in "block in run_callbacks'
/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
callbacks.rb:118:in ‘block in run_callbacks'
/usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in " se
t_topbar_sweeper_controller'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/
callbacks.rb:118:1in "block in run_callbacks'
/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1ib/audited/sweeper.rb:14:in “a
round'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
callbacks.rb:118:in ‘block in run_callbacks'
/opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1ib/audited/sweeper.rb:14:in ‘a
round'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/
callbacks.rb:118:in "block in run_callbacks'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
callbacks.rb:136:in "run_callbacks'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/abstract_controlle
r/callbacks.rb:41:in "“process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_controller/
metal/rescue.rb:22:in “process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_controller/
metal/instrumentation.rb:34:in “block in process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
notifications.rb:168:in “block in instrument'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
notifications/instrumenter.rb:23:in " instrument’'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1ib/active_support/
notifications.rb:168:in "instrument'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_controller/
metal/instrumentation.rb:32:in ‘process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_controller/
metal/params_wrapper.rb:256:1in “process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activerecord-5.2.1/1lib/active_record/ra
ilties/controller_runtime.rb:24:in ‘process_action'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/abstract_controlle
r/base.rb:134:in "“process'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionview-5.2.1/1ib/action_view/render
ing.rb:32:in “process'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_controller/
metal.rb:191:in “dispatch’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_controller/
metal.rb:252:1in “dispatch’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/ro
uting/route_set.rb:52:in “dispatch’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/ro
uting/route_set.rb:34:in "serve'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/ro
uting/mapper.rb:18:in “block in &lt;class:Constraints&gt; '
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/ro
uting/mapper.rb:48:in " serve'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/jo
urney/router.rb:52:in ‘block in serve'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/jo
urney/router.rb:35:in “each'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/jo
urney/router.rb:35:in "“serve'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/ro
uting/route_set.rb:840:in “call'
/opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.14.0.25/1ib/katello/middleware/even
t_daemon.rb:10:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.14/1ib/apipie/static_dispatc
her.rb:65:in “call'
/opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.14/1lib/apipie/extractor/reco
rder.rb:137:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/usr/share/foreman/lib/foreman/middleware/telemetry.rb:10:in “call'
/opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.14/1ib/apipie/middleware/che
cksum_in_headers.rb:27:in “call'
/usr/share/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/tempfile_reaper.rb:
15:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/etag.rb:25:in “call

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1ib/rack/conditional_get.rb:
38:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/head.rb:12:in ‘call

/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/ht
tp/content_security_policy.rb:18:in “call'
/usr/share/foreman/lib/foreman/middleware/logging_context_session.rb:22:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1ib/rack/session/abstract/id
.rb:232:in "“context'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1ib/rack/session/abstract/id
.rb:226:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/cookies.rb:670:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/callbacks.rb:28:in “block in call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
callbacks.rb:98:in "run_callbacks'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/callbacks.rb:26:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/debug_exceptions.rb:61l:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/show_exceptions.rb:33:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/rack/logger.rb
:38:in “call_app'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/rack/logger.rb
:28:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/sprockets-rails-3.2.1/1ib/sprockets/rai
ls/quiet_assets.rb:13:in “call'
/usr/share/foreman/lib/foreman/middleware/logging_context_request.rb:11:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/remote_ip.rb:81l:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/request_id.rb:27:in “call'
/opt/theforeman/tfm/root/usr/share/gems/gems/katello-3.14.0.25/1ib/katello/prevent_json_pa
rsing.rb:12:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1ib/rack/method_override.rb:
22:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/runtime.rb:22:in “c
all'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/activesupport-5.2.1/1lib/active_support/
cache/strategy/local_cache_middleware.rb:29:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/executor.rb:14:in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1ib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/actionpack-5.2.1/1lib/action_dispatch/mi
ddleware/static.rb:127:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1ib/rack/sendfile.rb:111:in
‘call!
/opt/theforeman/tfm/root/usr/share/gems/gems/secure_headers-6.0.0/1ib/secure_headers/middl
eware.rb:13:in “call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/engine.rb:524:
in “call’
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/railtie.rb:190
:in “public_send'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/railties-5.2.1/1ib/rails/railtie.rb:190
:in "method_missing'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/urlmap.rb:68:in “bl
ock in call'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/urlmap.rb:53:in “ea
ch'
/opt/theforeman/tfm-ror52/root/usr/share/gems/gems/rack-2.0.6/1lib/rack/urlmap.rb:53:in “ca
11"
/usr/share/gems/gems/passenger—4.0.18/1ib/phusion_passenger/rack/thread_handler_extension.
rb:77:in "process_request'
/usr/share/gems/gems/passenger-4.0.18/1ib/phusion_passenger/request_handler/thread_handler
.rb:140:1n "“accept_and_process_next_request'
/usr/share/gems/gems/passenger-4.0.18/1ib/phusion_passenger/request_handler/thread_handler
.rb:108:1in "main_loop'
/usr/share/gems/gems/passenger-4.0.18/1ib/phusion_passenger/request_handler.rb:441:in “blo
ck (3 levels) in start_threads'
/opt/theforeman/tfm/root/usr/share/gems/gems/logging-2.2.2/1ib/logging/diagnostic_context.
rb:474:in "block in create_with_logging_context'
2020-10-14T20:17:00 [I|apple77£5501] Rendering api/v2/errors/custom_error. json.rabl with
in api/v2/layouts/error_layout
2020-10-14T20:17:00 [I|apple77£5501] Rendered api/v2/errors/custom_error. json.rabl withi
n api/v2/layouts/error_layout (0.8ms)
2020-10-14T20:17:00 [I|apple77£5501] Completed 500 Internal Server Error in 1760ms (Views:
2.0ms | ActiveRecord: 543.7ms)

COMMAND RAN:

hammer> template combination create —--provisioning-template-id=55 --hostgroup-id=5
Template combination created.

SUCCESS IN FOREMAN/PRODUCTION.LOG:

2020-10-14T20:17:07 [I|appl|7eba85ab] Started POST "/api/hostgroups/5/template_combinations" for 19
2.168.0.24 at 2020-10-14 20:17:07 -0400

2020-10-14T20:17:07 [I|appl|7eba85ab] Processing by Api::V2::TemplateCombinationsController
#create as JSON

2020-10-14T20:17:07 [I|appl|7eba85ab] Parameters: {"provisioning_ template_id"=>55, "templ
ate_combination"=>{"hostgroup_id"=>5}, "apiv"=>"v2", "hostgroup_id"=>"5"}

2020-10-14T20:17:08 [D|appl|7eba85ab] Authenticated user admin against INTERNAL authenticat
ion source

2020-10-14T20:17:08 [I|appl|7eba85ab] Authorized user admin (Admin User)
2020-10-14T20:17:08 [D|tax]|7eba85ab] Current location set to none
2020-10-14T20:17:08 [D|tax|7eba85ab] Current organization set to none
2020-10-14T20:17:08 [D|tax|7eba85ab]
2020-10-14T20:17:08 [D|tax|7eba85ab]
2020-10-14T20:17:08 [I|appl|7eba85ab]

Current location set to none
Current organization set to none
Rendering api/v2/template_combinations/create. json.

rabl

2020-10-14T20:17:08 [I|appl7eba8bab] Rendered api/v2/template_combinations/create. json.r
abl (4.9%ms)

2020-10-14T20:17:08 [D|appl|7eba85ab] Body: {"created_at":"2020-10-15 00:17:08 UTC", "update
d_at":"2020-10-15 00:17:08 UTC","id":7,"provisioning_template_id":55, "provisioning_template_name":

"ansible_provisioning_callback", "hostgroup_id":5, "hostgroup_name":"chandler", "environment_id":null
,"environment_name":null, "config_template_id":55,"config_template_name":"ansible_provisioning_call
back"}

2020-10-14T20:17:08 [I|appl|7eba85ab] Completed 201 Created in 172ms (Views: 5.7ms | Active
Record: 54.5ms)

Version-Release number of selected component (if applicable):
Satellite 6.7.2

How reproducible:
always

Steps to Reproduce:

1. Run "hammer template combination create" command like so (with valid ids for each flag): # hammer template combination
create --provisioning-template-id=55 --hostgroup-id=5 --organization-id=1 --location=2"

2.

3.

Actual results:
Commnand fails with internal server error.

Expected results:
Expect command to succeed

Additional info:
